################################################################
plotGnuplotBars = function(X=c(1,2,3,4), X1A=c(10,50,23,30), X1B=c(90,50,77,70), X2A=c(10,50,23,30), X2B=c(90,50,77,70), labelX="X", labelY="Y", labelX1="LabelX1", labelX2="labelX2", labelXA="labelXA", labelXB="labelXB"){

  outFile = file("./tmp/gnuplotbars.data", "w")
  cat(file=outFile,"=stackcluster;",labelXA,";",labelXB,"\n", sep="")
  cat(file=outFile,"=sortbmarks","\n", sep="")
  cat(file=outFile,"=nogridy","\n", sep="")
  cat(file=outFile,"=noupperright","\n", sep="")
  cat(file=outFile,"legendx=7000","\n", sep="")
  cat(file=outFile,"legendy=1800","\n", sep="")
  cat(file=outFile,"xlabel=",labelX,"\n", sep="")
  cat(file=outFile,"ylabel=",labelY,"\n", sep="")
  cat(file=outFile,"=table","\n", sep="")
  cat(file=outFile,"multimulti=",labelX1,"\n", sep="")
  write.table(file=outFile,data.frame(X,X1A,X1B),row.names=FALSE,col.names=FALSE)
  cat(file=outFile,"multimulti=",labelX2,"\n", sep="")
  write.table(file=outFile,data.frame(X,X2A,X2B),row.names=FALSE,col.names=FALSE)
  close(outFile)

  system("./bin/bargraph.pl ./tmp/gnuplotbars.data > ./fig/gnuplotbars.eps")
  system("evince ./fig/gnuplotbars.eps")
} 

################################################################
gnuplot3D = function (X,Y,Z,minX=0,maxX=5,minY=0,maxY=5,minZ=0,maxZ=5,labelX="X",labelY="Y",labelZ="Z") {
  #export data to gnuplot file
  outFile = file("./tmp/gnuplot3d.data", "w")
  cat("#",labelX,labelY,labelZ,"\n",sep=" ")
  write.table(data.frame(X,Y,Z), file = outFile , row.names = FALSE, col.names = FALSE)
  close(outFile)
   
  #export gnuplot script
  outFile = file("./tmp/gnuplot3d.script", "w")
  cat(file = outFile, sep = "", "set xrange [",minX, ":",maxX,"]\n")
  cat(file = outFile, sep = "", "set yrange [",minY, ":",maxY,"]\n")
  cat(file = outFile, sep = "", "set zrange [",minZ, ":",maxZ,"]\n")
  cat(file = outFile, sep="", "set xlabel \"",labelX,"\"\n")
  cat(file = outFile, sep="", "set ylabel \"",labelY,"\"\n")
  cat(file = outFile, sep="", "set zlabel \"",labelZ,"\"\n")
  cat(file = outFile, "splot './tmp/gnuplot3d.data' w points\n")
  close(outFile)

  #call gnuplot and present 3D data
  system("gnuplot -persist ./tmp/gnuplot3d.script")
}
################################################################
################################################################
################################################################
################################################################
################################################################


dumbBellBw = read.table("./dat/raw.data")

# Plot comparative sharing for B fixed to 1e8 (100MB)
auxTableGT = dumbBellBw[((dumbBellBw$Latency >= 0.01)&(dumbBellBw$Bandwidth == 1e8)&(dumbBellBw$Model == 'GTNets')),]
auxTableLV = dumbBellBw[((dumbBellBw$Latency >= 0.01)&(dumbBellBw$Bandwidth == 1e8)&(dumbBellBw$Model == 'CM02')),]
plotGnuplotBars(X=auxTableGT$Latency, auxTableGT$ResultBandwidthFlowA, auxTableGT$ResultBandwidthFlowB, auxTableLV$ResultBandwidthFlowA, auxTableLV$ResultBandwidthFlowB, labelX="Latency", labelY="Instantaneous Bandwidth Share", labelX1="GTNetS", labelX2="SimGrid", labelXA="Flow A", labelXB="Flow B")


auxTableGT = dumbBellBw[((dumbBellBw$Latency >= 0.01)&(dumbBellBw$Bandwidth > 4e9)&(dumbBellBw$Model == 'GTNets')),]
auxTableLV = dumbBellBw[((dumbBellBw$Latency >= 0.01)&(dumbBellBw$Bandwidth > 4e9)&(dumbBellBw$Model == 'CM02')),]
plotGnuplotBars(X=auxTableGT$Latency, auxTableGT$ResultBandwidthFlowA, auxTableGT$ResultBandwidthFlowB, auxTableLV$ResultBandwidthFlowA, auxTableLV$ResultBandwidthFlowB, labelX="Latency", labelY="Instantaneous Bandwidth Share", labelX1="GTNetS", labelX2="SimGrid", labelXA="Flow A", labelXB="Flow B")



errorA = abs(log(auxTableLV$ResultBandwidthFlowA) - log(auxTableGT$ResultBandwidthFlowA))
errorB = abs(log(auxTableLV$ResultBandwidthFlowB) - log(auxTableGT$ResultBandwidthFlowB))
max(errorA)
max(errorB)



auxTableGT = dumbBellBw[((dumbBellBw$Model == 'GTNets')&(dumbBellBw$Bandwidth > 1e4)),]
gnuplot3D(auxTableGT$Latency,auxTableGT$Bandwidth,auxTableGT$ResultBandwidthFlowA/auxTableGT$ResultBandwidthFlowB,maxX=max(auxTableGT$Latency),maxY=max(auxTableGT$Bandwidth),maxZ=20,labelX="Latency",labelY="Bandwidth",labelZ="Ratio")


# Plot comparative sharing for B fixed to 1e5 (0.1MB)
auxTableGT = dumbBellBw[((dumbBellBw$Latency > 0.01)&(dumbBellBw$Bandwidth == 1e5)&(dumbBellBw$Model == 'GTNets')),]
auxTableLV = dumbBellBw[((dumbBellBw$Latency > 0.01)&(dumbBellBw$Bandwidth == 1e5)&(dumbBellBw$Model == 'CM02')),]
plotGnuplotBars(X=auxTableGT$Latency, auxTableGT$ResultBandwidthFlowA, auxTableGT$ResultBandwidthFlowB, auxTableLV$ResultBandwidthFlowA, auxTableLV$ResultBandwidthFlowB, labelX="Latency", labelY="Instantaneous Bandwidth Share", labelX1="GTNetS", labelX2="CM02", labelXA="Flow A", labelXB="Flow B")


# Plot comparative sharing for B fixed to 1e5 (0.1MB)
auxTableGT = dumbBellBw[((dumbBellBw$Latency >= 0.01)&(dumbBellBw$Bandwidth == 1e5)&(dumbBellBw$Model == 'GTNets')),]
auxTableLV = dumbBellBw[((dumbBellBw$Latency >= 0.01)&(dumbBellBw$Bandwidth == 1e5)&(dumbBellBw$Model == 'LV08')),]
plotGnuplotBars(X=auxTableGT$Latency, auxTableGT$ResultBandwidthFlowA, auxTableGT$ResultBandwidthFlowB, auxTableLV$ResultBandwidthFlowA, auxTableLV$ResultBandwidthFlowB, labelX="Latency", labelY="Instantaneous Bandwidth Share", labelX1="GTNetS", labelX2="LV08", labelXA="Flow A", labelXB="Flow B")

